﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Reflection;
using System.Windows.Documents;
using System.Xml.Linq;

namespace C1TreeViewC1FlexGrid_DragDrop
{
    public class DataLoader
    {
        //loads Items from xml
        public static List<Item> LoadItems()
        {
            XDocument doc = XDocument.Load(new StreamReader(Assembly.GetExecutingAssembly().GetManifestResourceStream("C1TreeViewC1FlexGrid_DragDrop.data.subCategoriesItems.xml")));
            var items = from item in doc.Descendants("Item")
                            select new Item
                            {
                                ItemID = int.Parse(string.IsNullOrEmpty(item.Element("ItemID").Value) ? "-1" : item.Element("ItemID").Value),
                                Name = item.Element("Name").Value,
                                Title = item.Element("Title").Value,
                                SubCategoryID = int.Parse(string.IsNullOrEmpty(item.Element("SubCategoryID").Value) ? "-1" : item.Element("SubCategoryID").Value),
                                Neck =  (Item.NeckTypeEnum)Enum.Parse(typeof(Item.NeckTypeEnum), item.Element("Neck").Value),
                                BrandName = (Item.BrandEnum)Enum.Parse(typeof(Item.BrandEnum), item.Element("BrandName").Value),
                                Price = double.Parse(string.IsNullOrEmpty(item.Element("Price").Value) ? "-1" : item.Element("Price").Value)
                            };

            List<Item> itemList = new List<Item>();
            foreach (var item in items)
            {
                itemList.Add(item);
            }
            return itemList;
        }

        //loads the Categories
        public static List<Category> LoadCategories()
        {
            XDocument doc = XDocument.Load(new StreamReader(Assembly.GetExecutingAssembly().GetManifestResourceStream("C1TreeViewC1FlexGrid_DragDrop.data.categories.xml")));
            var categories = from category in doc.Descendants("Category")
                            select new Category
                            {
                                CategoryID = int.Parse(string.IsNullOrEmpty(category.Element("CategoryID").Value) ? "-1" : category.Element("CategoryID").Value),
                                Name = category.Element("Name").Value,
                            };

            List<Category> categoryList = new List<Category>();
            foreach (var category in categories)
            {
                categoryList.Add(category);
            }
            return categoryList;
        }
        
        //loads the SubCategories
        public static List<SubCategory> LoadSubCategories()
        {
            XDocument doc = XDocument.Load(new StreamReader(Assembly.GetExecutingAssembly().GetManifestResourceStream("C1TreeViewC1FlexGrid_DragDrop.data.subCategories.xml")));
            var subCategories = from subCategory in doc.Descendants("SubCategory")
                                select new SubCategory
                                {
                                    SubCategoryID = int.Parse(string.IsNullOrEmpty(subCategory.Element("SubCategoryID").Value) ? "-1" : subCategory.Element("SubCategoryID").Value),
                                    Name = subCategory.Element("Name").Value,
                                    SubCategoryName = subCategory.Element("SubCategoryName").Value,
                                    CategoryID = int.Parse(string.IsNullOrEmpty(subCategory.Element("CategoryID").Value) ? "-1" : subCategory.Element("CategoryID").Value)
                                };

            List<SubCategory> subCategoriesList = new List<SubCategory>();
            foreach (var subCategory in subCategories)
            {
                subCategoriesList.Add(subCategory);
            }
            return subCategoriesList;
        }
    }
}
